<?php
/**
 * Created by JetBrains PhpStorm.
 * User: gustavoavila
 * Date: 18/10/12
 * Time: 16:56
 * To change this template use File | Settings | File Templates.
 */
class ger80900_01Logic extends FctLogic
{

    public function __construct()
    {
        $cdregra = $this->getCdregrafisc();
        parent::__construct(Regrafiscal::getObjectByWhereOrNew("CDREGRAFISC = ?", array($cdregra)));
    }

    public static function geraNovoCodigo()
    {
        $codigo = Novocodigo::geraCodigo(Ambiente::getNrorg(), 'REGRAFISCAL', 10, 1);
        return $codigo;
    }

    public function validaAtivacao($cdregrafiscal)
    {
        try{
            $resultSet = RegrafiscalEntity::consultaErrosAtivacaoRegrafisc($cdregrafiscal);
            if(empty($resultSet)) return true;
            $errors = array();
            foreach($resultSet as $row) {
                $error = self::getError($row["IDERRO"]);
                if ($error) {
                    $errors[] = $error;
                }
            }

            return $errors;

        } catch(Exception $e) {
            throw $e;
        }
    }

    public function validaDelete($cdregrafiscal)
    {
        try{
            $resultSet = VinculofisregraEntity::existeVinculo($cdregrafiscal);
            return empty($resultSet);
        } catch(Exception $e) {
            throw $e;
        }
    }

    private static function getError($error_code)
    {
        $errors = array(
             0  => "Não há vínculo algum para a respectiva regra fiscal.",
             1  => "Imposto Obrigatório sem dados fiscais (padrão, por NCM e/ou por produto).",
             2  => "Imposto exige CFOP e a regra não possui parametrização de CFOP.",
             3  => "Imposto exige CST e existem dados fiscais (padrão, por NCM e/ou por produto) sem CST.",
             4  => "CST não cadastrado para o imposto.",
             5  => "Código Fiscal inválido para o respectivo CST e imposto.",
             6  => "CST inválido para imposto cujo valor de alíquota é definido por quantidade.",
             7  => "Tipo de Crédito e natureza da base de cálculo obrigatórios para o respectivo imposto e CST.",
             8  => "Valor de alíquota inválida para o respectivo imposto e CST .",
             9  => "Vínculo já cadastrado para outra regra fiscal ativa.",
             10 => "Natureza da Receita é obrigatória para o respectivo imposto e CST.",
             11 => "Regra não utiliza grupo fiscal porém, existem grupos fiscais parametrizados.",
             12 => "Regra utiliza grupo fiscal porém, não existem grupos fiscais parametrizados."
        );
        return isset($errors[$error_code]) ? $errors[$error_code] : false;
    }
}
