<?php
/**
 * Created by JetBrains PhpStorm.
 * User: gustavoavila
 * Date: 29/10/12
 * Time: 13:38
 * To change this template use File | Settings | File Templates.
 */
class ger80900_04Logic extends FctLogic
{

    static $_storedInSession = array("IDUTUFORIG","IDUTUFDEST","IDUTFAIXVLR","IDUTREDUBC","ID1UTREDUBC","IDUTPARCDED","IDTPIMPOSFIS");

    public function __construct($useSession = true)
    {
        parent::__construct(new CfopadraoregfisEntity());
        if($useSession) {
            parent::storedInSession(self::$_storedInSession, ger80900_01::WINDOW_NAME);
        }
    }

    public function validaSave()
    {
        $keys = CfoppadraoEntity::consultaTodosCdcfoppadrao();
        if(empty($keys)) throw new Exception("Nenhum CFOP padrão cadastrado.");
        $equals = array();
        $callback = function($el){
            return substr($el["CDCFOPPADRAO"], 1, strlen($el["CDCFOPPADRAO"]));
        };
        $validKeys = array_map($callback, $keys);
        $equals[0] = false;
        if(!in_array($this->getCdfiscoper(), $validKeys)){
            $equals[0] = "Código Fiscal não existe.";
        }
        $resultSet = CfopregrafiscalEntity::consultaCfopregrafiscal($this->getCdregrafisc());
        if(empty($resultSet)) return true;
        foreach($resultSet as $row) {
            $equals[1] = false;
            if($row["CDPRODUTO"] == $this->getCdproduto()) {
                $equals[1] = "Registro com código do produto já cadastrado.";
            }
            $equals[2] = false;
            if($row["CDFISCOPER"] == $this->getCdfiscoper()) {
                $equals[2] = "Código fiscal já cadastrado.";
            }
            $equals[3] = false;
            if($row["IDCFOPINTEREST"] == $this->getIdcfopinterest()) {
                $equals[3] = "Registro com Operação Interestadual já cadastrado.";
            }
        }
        $filterCallback = function($el) {
            if($el !== false) {
                return $el;
            }
        };
        $errors = array_filter($equals, $filterCallback);
        return $errors;
    }

}
