/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ALMX                                                     */
/* Tabela : ALMOXARIFADO                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 18/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_ALMX
BEFORE INSERT OR UPDATE OR DELETE
ON ALMOXARIFADO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUALMX := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDALMOXARIFE,0) <> NVL(:NEW.CDALMOXARIFE,0)) OR
         (NVL(:OLD.DSALMOXARIFE,0) <> NVL(:NEW.DSALMOXARIFE,0)) OR
         (NVL(:OLD.CDFILIAL,0)     <> NVL(:NEW.CDFILIAL,0)) THEN
         :NEW.DTULTATUALMX := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('ALMOXARIFADO', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';CDALMOXARIFE='||:OLD.CDALMOXARIFE||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE ALMOXARIFADO MODIFY DTULTATUALMX DEFAULT SYSDATE
/
